Category: GUI

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution: worksforme

Crashes QGIS or corrupts data:No Copied to github as #: 16675

Description

When one tests the layer filter expression, the number of rows showed is the total number of row in the layer instead of the result of the

filter.

The filter works well.

Does not happen in 1.8, it's a regression, so I set it as a blocker.

Related issues:

Duplicated by QGIS Application - Bug report # 8503: Postgis query test return... Closed 2013-08-22

Duplicated by QGIS Application - Bug report # 12545: Wrong features count fil... Closed 2015-04-10

Duplicated by QGIS Application - Bug report # 14542: Test of query of a postg... Closed 2016-03-21

History

#1 - 2013-05-13 06:01 AM - Matthias Kuhn

- Priority changed from Severe/Regression to Normal

From qgspostgresprovider.cpp (Line 2315):

  // use estimated metadata even when there is a where clause,

  // although we get an incorrect feature count for the subset

  // - but make huge dataset usable.

  if ( !mIsQuery && mUseEstimatedMetadata )

The currently supported solution is to disable "Use estimated metadata" for your database connection.

If you see a better way of managing this issue, please share your ideas. I have changed the priority to Normal since this is expected behavior (although

admittedly odd)

#2 - 2014-01-27 01:57 AM - Alexandre Neto

I would not mind passing this issue to "Feature". And if there is no better solution, we could inform the user that he estimated metadata was used and

therefore the showed values might not be accurate.

#3 - 2014-01-27 02:01 AM - Paolo Cavallini
- Subject changed from Incorrect number o rows when testing layer filter expression to Incorrect number of rows when testing layer filter expression

#4 - 2014-01-30 11:41 PM - Paolo Cavallini

- Target version changed from Version 2.0.0 to Future Release - High Priority

#5 - 2014-03-25 08:59 AM - Sandro Santilli

I was also bitten by this problem, still in 2.0 and in 2.2.

Being a regression from 1.8 I don't see how it becomes a feature request.

Another thing I don't see is why mIsQuery should disable estimation while filter should not, they both basically introduce a filtering, so should be both

threated the same way, IMHO (ie: disabling the estimation)

#6 - 2017-05-01 01:09 AM - Giovanni Manghi

- Regression? set to No

- Easy fix? set to No

#7 - 2017-05-02 12:18 PM - Alexandre Neto

As far I understand, the "Use Estimated metadata" is not used by default. I can't remember if that was the case back then... anyway, I would close this

ticket, the behavior is fully documented in here:

http://docs.qgis.org/2.18/en/docs/user_manual/working_with_vector/supported_data.html#creating-a-stored-connection

#8 - 2017-05-02 02:42 PM - Jürgen Fischer

- Resolution set to worksforme

- Description updated

- Status changed from Open to Closed
